<main data-component="line">
    <form [formGroup]="lineForm">
        <div class="grid-container">
            <div class="grid-item">
                <article style="width: 97%;">
                    <mat-form-field floatLabel="always" title="Select a method of supply">
                        <mat-label>{{fieldSupplied.title}}</mat-label>
                        <mat-select formControlName="{{fieldSupplied.field}}" id="supplied"
                            (selectionChange)="suppliedChangedZoomPanel($event.value)"
                            (ngModelChange)="paramChange()">
                            <ng-container *ngFor="let item of fieldSupplied.defaultValue">
                                <mat-option [value]="item.value">{{item.displayValue}}</mat-option>
                            </ng-container>
                        </mat-select>
                    </mat-form-field>
                  <article style="width: 50%;" class="field-with-units" *ngIf="getSupplied() ==='IntegrationTime'">
                    <mat-form-field style="width: 100%" floatLabel="always" title={{fieldIntegrationTime.description}}>
                        <mat-label>{{fieldIntegrationTime.title}}</mat-label>
                        <input matInput placeholder="{{fieldIntegrationTime.placeholder}}"
                            formControlName="{{fieldIntegrationTime.field}}"
                            (ngModelChange)="paramChange()">
                        <mat-error>{{getErrorMessage('fieldIntegrationTime')}}</mat-error>
                    </mat-form-field>
                        <span class="units-button">
                            <button mat-button style="text-transform: none;" [matMenuTriggerFor]="integrationTimeSelection"
                                matTooltip="Expand to change time operator" matTooltipPosition="left"
                                disabled="{{lineForm.get('fieldIntegrationTime')!.disabled}}">
                                <span class="button-text">
                                    {{ selectedIntegrationTime.value }}
                                    <fa-icon class="icon" [icon]="faCaretDown" aria-hidden="false" diabled></fa-icon>
                                </span>
                            </button>
                            <mat-menu #integrationTimeSelection="matMenu">
                                <ng-container *ngFor="let time of defaultTimeDropdownOptions">
                                    <button mat-menu-item (click)="selectIntegrationTime(time)">
                                        {{ time.value }}</button>
                                </ng-container>
                            </mat-menu>
                        </span>
                </article>
                  <article style="width: 50%;" class="field-with-units" *ngIf="getSupplied() ==='Sensitivity'">
                    <mat-form-field style="width: 100%" floatLabel="always" title={{fieldSensitivity.description}}>
                        <mat-label>{{fieldSensitivity.title}}</mat-label>
                        <input matInput placeholder="{{fieldSensitivity.placeholder}}"
                          formControlName="{{fieldSensitivity.field}}"
                          (ngModelChange)="paramChange()">
                        <mat-error>{{getErrorMessage('fieldSensitivity')}}</mat-error>
                    </mat-form-field>
                    <span class="units-button">
                        <button mat-button style="text-transform: none;" [matMenuTriggerFor]="sensitivitySelection"
                            matTooltip="Expand to change sensitivity operator" matTooltipPosition="left"
                            disabled="{{lineForm.get('fieldSensitivity')!.disabled}}">
                            <span class="button-text">
                                {{ selectedSensitivity.value }}
                                <fa-icon class="icon" [icon]="faCaretDown" aria-hidden="false"></fa-icon>
                            </span>
                        </button>
                        <mat-menu #sensitivitySelection="matMenu">
                            <ng-container *ngFor="let sensitivity of defaultSensitivityDropdownOptions">
                                <button mat-menu-item (click)="selectSensitivity(sensitivity)">
                                    {{ sensitivity.value }}</button>
                            </ng-container>
                        </mat-menu>
                    </span>
                  </article>
                </article>
                <div class="field-with-units">
                  <mat-form-field floatLabel="always" title={{fieldZoomFrequency.description}}>
                      <mat-label>Central Frequency</mat-label>
                      <input matInput placeholder="{{fieldZoomFrequency.placeholder}}"
                             formControlName="{{fieldZoomFrequency.field}}"
                             (ngModelChange)="freqParamChange()"
                             required>
                      <mat-error>
                          {{getErrorMessage('fieldZoomFrequency')}}
                      </mat-error>
                  </mat-form-field>
                  <span class="units-button">
                        <button mat-button style="text-transform: none;" [matMenuTriggerFor]="zoomFreqSelection"
                            type="button" matTooltip="Expand to change frequency operator"
                            matTooltipPosition="left">
                            <span class="button-text">
                                {{ selectedZoomFrequency.value }}
                                <fa-icon class="icon" [icon]="faCaretDown" aria-hidden="false"></fa-icon>
                            </span>
                        </button>
                        <mat-menu #zoomFreqSelection="matMenu">
                            <ng-container *ngFor="let frequency of defaultFrequencyDropdownOptions">
                                <button mat-menu-item (click)="selectZoomFrequency(frequency)">
                                    {{ frequency.value }}</button>
                            </ng-container>
                        </mat-menu>
                    </span>
                </div>
                <mat-form-field floatLabel="always" title={{fieldZoomResolution.description}}>
                    <mat-label>Bandwidth and Spectral Resolution</mat-label>
                    <mat-select formControlName="{{fieldZoomResolution.field}}"
                        (selectionChange)="resolutionChanged($event.value)"
                        (ngModelChange)="paramChange()">
                        <ng-container *ngFor="let resolution of defaultResolutionDropdownOptions">
                            <mat-option [value]="resolution.value">{{getResolutionDisplayValue(resolution.value,
                                resolution.bandwidth, resolution.displayValue)}}</mat-option>
                        </ng-container>
                    </mat-select>
                    <mat-error>{{getErrorMessage('fieldZoomResolution')}}</mat-error>
                </mat-form-field>

                <article style="width: 97%;">
                    <mat-form-field floatLabel="always" title={{fieldZoomSpectralAveraging.description}}>
                        <mat-label>Spectral Averaging</mat-label>
                        <mat-select formControlName="{{fieldZoomSpectralAveraging.field}}"
                                    required
                                    (selectionChange)="spectralAveragingChanged($event.value)"
                                    (ngModelChange)="paramChange()">
                            <ng-container *ngFor="let item of spectralAveragingOptions">
                                <mat-option [value]="item.value">{{item.value}}</mat-option>
                            </ng-container>
                        </mat-select>
                        <mat-error>{{getErrorMessage('fieldZoomSpectralAveraging')}}</mat-error>
                    </mat-form-field>

                    <mat-form-field floatLabel="always" title={{fieldEffectiveResolution.description}}>
                        <mat-label>Effective Resolution</mat-label>
                        <input matInput placeholder="{{fieldEffectiveResolution.placeholder}}"
                            formControlName="{{fieldEffectiveResolution.field}}" readonly
                            (ngModelChange)="paramChange()">
                        <mat-error>{{getErrorMessage('fieldEffectiveResolution')}}</mat-error>
                    </mat-form-field>
                </article>

                <article style="{{imageWeightingStyle}}">
                  <mat-form-field title={{fieldImageWeighting.description}}>
                      <mat-label>{{fieldImageWeighting.title}}</mat-label>
                      <mat-select formControlName="{{fieldImageWeighting.field}}"
                                  required
                                  (selectionChange)="weightingChanged($event.value)"
                                  (ngModelChange)="paramChange()">
                          <ng-container *ngFor="let item of fieldImageWeighting.defaultValue">
                              <mat-option [value]="item.value">{{item.option}}</mat-option>
                          </ng-container>
                      </mat-select>
                  </mat-form-field>

                  <mat-form-field  *ngIf="showRobustness" style="margin-right: 10px;"
                                  title={{fieldRobust.description}}>
                      <mat-label>{{fieldRobust.title}}</mat-label>
                      <mat-select formControlName="{{fieldRobust.field}}"
                                  required
                                  (selectionChange)="paramChange()"
                                  (ngModelChange)="paramChange()">
                          <ng-container *ngFor="let robustness of fieldRobust.defaultValue">
                              <mat-option [value]="robustness">{{robustness}}</mat-option>
                          </ng-container>
                      </mat-select>
                  </mat-form-field>

                    <mat-form-field floatLabel="always" title={{fieldTapering.description}}>
                        <mat-label>{{fieldTapering.title}}</mat-label>
                        <mat-select formControlName="{{fieldTapering.field}}" (selectionChange)="paramChange()">
                            <ng-container *ngFor="let taper of getTaperValues(); let i = index">
                                <mat-option [value]="taper">{{midCalcService.getDisplayedTaper(taper, getScaledFrequency())}}{{i !== 0 ? '"' : ''}}
                                </mat-option>
                            </ng-container>
                        </mat-select>
                    </mat-form-field>
              </article>
          </div>
            <div class="grid-item">
                <app-zoom-results [zoomResults]="zoomResults"></app-zoom-results>
            </div>
        </div>
    </form>
</main>
